/*  Copyright 2005 Fabien Coulon

    This file is part of OpenEuclide

    OpenEuclide is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OpenEuclide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OpenEuclide; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _MY_ARCHIVE_H_
#define _MY_ARCHIVE_H_

#include <fstream>
#include <string>
#include "Vect.h"
using namespace std;

#define ECL_FILE_SIGNATURE 0x6f42c89e
#define ECL_FILE_VERSION 0

#define TYPE_MEMORY_STORE 3
#define TYPE_MEMORY_LOAD 4
#define TYPE_MEMORY_EVAL 2
#define TYPE_CLOSE -1

class CMyArchive  {
 public:
  CMyArchive();
  ~CMyArchive();
  void fromStream( ifstream& is );
  void toStream( ofstream& os ) const;
  bool signature( int v ) const;
  
  void  CloseEvaluating();
  void	CloseStoring();
  void	RestoreLoading();
  bool	IsStoring() const;
  bool	IsLoading() const;
  bool  IsEvaluating() const;

  void  setType( int id );
  int   getType();
  
  CMyArchive& operator << ( int v );
  CMyArchive& operator << ( bool v );
  CMyArchive& operator << ( double v );
  CMyArchive& operator << ( char v );
  CMyArchive& operator << ( Vect v );
  CMyArchive& operator << ( const string& v );
  
  CMyArchive& operator >> ( int& v );
  CMyArchive& operator >> ( bool& v );
  CMyArchive& operator >> ( double& v );
  CMyArchive& operator >> ( char& v );
  CMyArchive& operator >> ( Vect& v );
  CMyArchive& operator >> ( string& v );
  
 protected:
  int	 Type;
  long	 BufLen;
  char*	 Buf;
  char*	 Curs;

  int    fileVersion;
};

#endif
