/*  Copyright 2005 Fabien Coulon

    This file is part of OpenEuclide

    OpenEuclide is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OpenEuclide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OpenEuclide; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _UNDOBUFFER_H_
#define _UNDOBUFFER_H_

#include "MyArchive.h"

#define MAX_UNDO_BUFFERS 50

class CUndoBuffer  
{
 public:
  bool		OnTheTop();
  bool		GetUndoState();
  bool		GetRedoState();
  CMyArchive* GetUndoBuffer();
  CMyArchive* GetRedoBuffer();
  CMyArchive* GetNextBuffer();
  CUndoBuffer( int _n );
  virtual ~CUndoBuffer();
  
 protected:
  int		 iPlus( int i );
  int		 iMoins( int i );
  
  int		 n;
  int		 i;
  int		 iBottom;	// Bas de la pile
  CMyArchive*	Buffer[ MAX_UNDO_BUFFERS ];
};

#endif
