#include "euclideConf.h"
#include <envz.h>
#include <iostream>
#include <glib.h>

#define MAX_CONF_LEN 8000

string config::fileName = "";
char* config::confPtr = NULL;
size_t config::confLen = 0;

void config::init( char* envp[] ) {

  int len = 0;
  for ( int i=0; envp[i] != NULL; i++ )    
    len += strlen(envp[i]) + 1;

  fileName = g_get_home_dir();
  
  fileName += "/.openeuclide";

  ifstream is; is.open( fileName.c_str(), ios_base::in );
  if ( !is.good() ) {
    confPtr = new char[1]; confPtr[0] = 0;
    confLen = 0;
  }
  else  {
    confPtr = new char[MAX_CONF_LEN];
    confLen = is.readsome( confPtr, MAX_CONF_LEN );
    is.close();
  }
}

char* config::getString( const char* name ) {

  return envz_get( confPtr, confLen, name );
}

void config::setString( const char* name, const char* value ) {

  envz_add( &confPtr, &confLen, name, value );
  ofstream os; os.open( fileName.c_str(), ios_base::out );
  if ( os.good() ) os.write( confPtr, confLen );
  os.close();
}

int config::getInt( const char* name, int deflt ) {

  char* res = getString( name );
  if ( !res ) return deflt;
  return atoi( res );
}

void config::setInt( const char* name, const int value ) {

  char tmp[32];
  sprintf( tmp, "%d", value );
  setString( name, tmp );
}

