/*  Copyright 2005 Fabien Coulon

    This file is part of OpenEuclide

    OpenEuclide is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OpenEuclide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OpenEuclide; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// This file is for managing configuration file of OpenEuclide : $HOME/.openeuclide
// --------------------------------------------------------------------------------

#include <string>
#include <fstream>
#include <cstdlib>
using namespace std;

class config {

 public:
  static void init( char* envp[] );
  static char* getString( const char* name );
  static void setString( const char* name, const char* value );
  static int getInt( const char* name, int deflt = 0 );
  static void setInt( const char* name, int value );
 
 private:
  static string fileName;
  static char* confPtr;
  static size_t confLen;
};


