/*  Copyright 2005 Fabien Coulon

    This file is part of OpenEuclide

    OpenEuclide is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OpenEuclide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OpenEuclide; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _EUCLIDE_VIEW_H_
#define _EUCLIDE_VIEW_H_

#include <gtk/gtk.h>
#include "euclideDocument.h"

class euclideView {

 public:

  euclideView();
  ~euclideView();

  GtkWidget* createNoteBook();

  void create();
  bool open( string fileName );
  bool save();
  bool saveAs( const string& _name );
  void undo();
  void redo();
  void close();
  void aVoid();
  void selectAll();
  gboolean onClose();

  void createObject( guint idObj );

  bool dispatchLetter( char* letter );
  void detachFirstDocument();
  GtkWidget *noteBook() const { return notebook; }
  void attachStatusbar( GtkStatusbar* _statusbar );
  void setMessageText( string text );
  void pushLocalText( string text );
  void popLocalText();

  bool bLockPainting() const { return blockPainting; }
  void lockPainting( bool val ) { blockPainting = val; }
  void exportAsImage( const gchar* filename, gint xRes, bool _black );

 protected:

  euclideDocument* getDocument();
  
  GtkWidget *notebook;
  gint   noName;
  GtkStatusbar* statusbar;
  guint ctxLocal, ctxGeneral;
  bool bLocalText;
  bool blockPainting;
  
  euclideDocument* documents;
};

extern euclideView *view;


#endif
