/*  Copyright 2005 Fabien Coulon

    This file is part of OpenEuclide

    OpenEuclide is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OpenEuclide is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OpenEuclide; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _MLSTRING_H_
#define _MLSTRING_H_

#include <gtk/gtk.h>
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

#define MAX_MLSTRING_LENGTH 256

class mlEntry {
  
 public: 
  mlEntry( const string& filename );
  mlEntry( ifstream& is );
  int readThisLine( ifstream& is );
  const string* get( int id );
  
 protected:  
  int      bValid;
  int      idx;
  string    _str;
 
  mlEntry* sv;
};

class mlString {
  
 public:
  mlString();
  mlString( int idx );
  ~mlString() {}
  
  void loadString( int idx );
  void empty();
  static GtkItemFactoryEntry* elementsMenu(); 
  static int nbElementsMenu();
  static void select();
  static void force( int id );

  operator string() { return *_str; }
  
 protected:
  const string*  _str;

  static mlEntry* mlentry;
  static string* str_empty;
  static string mlFileName;
};


#endif
